var _verifyCustomAttributes = false;
jQuery('li.color-variable-item-rc').click(function() {
  jQuery(this).siblings().removeClass('selected');
  jQuery(this).addClass('selected');
  var _req = jQuery(this).parent().parent().siblings();
  _req.children('label').children('span').children('span').fadeOut('slow', function () {
    jQuery(this).css({display:"none"});
  });
  checkVerify();
  getCustomgetVariant();
  checkCustomgetVariant();
});
jQuery('li.image-variable-item-rc').click(function() {
  jQuery(this).siblings().removeClass('selected');
  jQuery(this).addClass('selected');
  var _req = jQuery(this).parent().parent().siblings();
  _req.children('label').children('span').children('span').fadeOut('slow', function () {
    jQuery(this).css({display:"none"});
  });
  checkVerify();
  getCustomgetVariant();
  checkCustomgetVariant();
});
jQuery('li.button-variable-item-rc').click(function() {
  jQuery(this).siblings().removeClass('selected');
  jQuery(this).addClass('selected');
  var _req = jQuery(this).parent().parent().siblings();
  _req.children('label').children('span').children('span').fadeOut('slow', function () {
    jQuery(this).css({display:"none"});
  });
  checkVerify();
  getCustomgetVariant();
  checkCustomgetVariant();
});
jQuery('select.my-select-dr').on('change', function() {
  if (this.value != '') {
    var _req = jQuery(this).parent().siblings();
    _req.children('label').children('span').children('span').fadeOut('slow', function () {
      jQuery(this).css({display:"none"});
    });
  } else {
    var _req = jQuery(this).parent().siblings();
    _req.children('label').children('span').children('span').fadeIn();
  }
  checkVerify();
  getCustomgetVariant();
  checkCustomgetVariant();
});

var VerifyCustomVariant = function() {
  var _ul = jQuery('ul.my-variable-items-wrapper');
  var _verifyCustomAttributes = true;
  if (_ul.length > 0) {
    _ul.each(function () {
      var _li = jQuery(this).children('li.selected');
      if (_li.length === 0) {
        _verifyCustomAttributes = false;
      }
    });
  }
  var _dd = jQuery('select.my-select-dr');
  if (_dd.length > 0) {
    _dd.each(function () {
      var str = jQuery(this).val() + '';
      if (str === '') {
        _verifyCustomAttributes = false;
      }
    });
  }

  return _verifyCustomAttributes;
}

var checkVerify = function () {
  if (VerifyCustomVariant()) {
    jQuery('a#btnPersonalize').removeClass('verify-custom-attributes-needed');
    jQuery('button.single_add_to_cart_button').removeClass('verify-custom-attributes-needed');
  } else {
    jQuery('a#btnPersonalize').addClass('verify-custom-attributes-needed');
    jQuery('button.single_add_to_cart_button').addClass('verify-custom-attributes-needed');
  }
}

var getCustomgetVariant = function() {
  var _customVariant = {
    data: []
  };

  var _ul = jQuery('ul.my-variable-items-wrapper');
  if (_ul.length > 0) {
    _ul.each(function () {
      var _attributeText, _attributeType, _attributeSlug, _termValueSlug, _termValueText, _termValueContent, _selectedTerm = '';
      _attributeText = jQuery(this).attr('data-attribute-text');
      _attributeType = jQuery(this).attr('data-attribute-type');
      _attributeSlug = jQuery(this).attr('data-attribute-name');
      var _li = jQuery(this).children('li.selected');
      if (_li.length > 0) {
        _termValueSlug = _li.attr('data-value');
        _termValueText = _li.attr('data-wvstooltip');
        _termValueContent = _li.attr('data-src');
        _selectedTerm = true;
      } else {
        _selectedTerm = false;
      }
      _customVariant.data.push({
        attribute_slug: _attributeSlug,
        attribute_name: _attributeText,
        attribute_display_type: _attributeType,
        term_name: _termValueText,
        term_slug: _termValueSlug,
        term_content: _termValueContent,
        term_selected: _selectedTerm
      });
    });
  }
  var _dd = jQuery('select.my-select-dr');
  if (_dd.length > 0) {
    _dd.each(function () {
      var _attributeText, _attributeType, _attributeSlug, _termValueSlug, _termValueText, _termValueContent, _selectedTerm = '';
      _attributeText = jQuery(this).attr('data-attribute-text');
      _attributeType = 'select';
      _attributeSlug = jQuery(this).attr('data-attribute-name');
      var str = jQuery(this).val() + '';
      if (str != '') {
        _termValueSlug = jQuery(this).find(':selected').attr('data-value');
        _termValueText = jQuery(this).find(':selected').val();
        _termValueContent = '';
        _selectedTerm = true;
      } else {
        _selectedTerm = false;
      }
      _customVariant.data.push({
        attribute_slug: _attributeSlug,
        attribute_name: _attributeText,
        attribute_display_type: _attributeType,
        term_name: _termValueText,
        term_slug: _termValueSlug,
        term_content: _termValueContent,
        term_selected: _selectedTerm
      });
    });
  }
  jQuery("input#personalized-custom-variant").val(JSON.stringify(_customVariant));
}

var checkCustomgetVariant = function() {
  var _dataCustomAttributeBefore = localStorage.getItem('custom-attributes-selected');
  var _dataCustomAttributeCurrent = jQuery("input#personalized-custom-variant").val();
  if (_dataCustomAttributeBefore != _dataCustomAttributeCurrent) {
    jQuery("a#btnPersonalize").text('PERSONALIZE');
    jQuery("a#btnPersonalize").removeClass('edit-design');
    jQuery("button.single_add_to_cart_button").removeClass('edit-design');
    jQuery("button.single_add_to_cart_button").removeClass('margin-left-50');
    jQuery("button.single_add_to_cart_button, div.wcppec-checkout-buttons").hide();
    jQuery("#wc-stripe-payment-request-wrapper, #wc-stripe-payment-request-button-separator").hide();
    jQuery("a#previewImg").hide();
  } else {
    jQuery("a#btnPersonalize").text('EDIT DESIGN');
    jQuery("a#btnPersonalize").addClass('edit-design');
    jQuery("button.single_add_to_cart_button").addClass('edit-design');
    jQuery("button.single_add_to_cart_button").addClass('margin-left-50');
    jQuery("button.single_add_to_cart_button, div.wcppec-checkout-buttons").show();
    jQuery("#wc-stripe-payment-request-wrapper, #wc-stripe-payment-request-button-separator").show();
    jQuery("a#previewImg").show();
  }
}

// temporary not use
// jQuery( "select.my-select" ).change(function() {
//   var str = "";
//   var _group = jQuery(this).data('group');
//   jQuery( 'ul.' + _group).addClass('invisible');
//   jQuery( 'li.' + _group + '-variable-item-rc').removeClass('selected');
//   str = jQuery(this).find(':selected').val() + '';
//   if (str != '') {
//     jQuery( 'ul#'+ str ).addClass(str);
//     jQuery( 'ul#'+ str ).removeClass('invisible');
//   }
// });
