function dastomize_js_additional_single_product_button(url, pid, sid, productId, webUrl, isCustomAttribute, textButtonPersonalize, isSimple) {
    var _verifyCustomAttributeNeededClass = '';
    if (isCustomAttribute) {
        _verifyCustomAttributeNeededClass = 'verify-custom-attributes-needed';
    }
    var fancyboxOptions = {
        type: 'iframe',
        baseClass: 'designRenderPreview-fancybox',
        touch: false,
        clickSlide: false,
        smallBtn: true,
        btnTpl: {
            smallBtn:
                `<button data-fancybox-close="" class="fancybox-button fancybox-button--close" title="Close" style="position: absolute;z-index: 1;top: 0px;right: 0px;height: 50px;width: 50px;">
                <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 10.6L6.6 5.2 5.2 6.6l5.4 5.4-5.4 5.4 1.4 1.4 5.4-5.4 5.4 5.4 1.4-1.4-5.4-5.4 5.4-5.4-1.4-1.4-5.4 5.4z"></path></svg>
            </button>`
        },
        iframe: {
            tpl: '<iframe id="fancybox-frame{rnd}" name="fancybox-frame{rnd}" data-hj-allow-iframe class="fancybox-iframe" allow="autoplay; fullscreen"  webkitAllowFullScreen mozallowfullscreen allowFullScreen src=""></iframe>',
        }
    };
    fancyboxOptions = JSON.stringify(fancyboxOptions);
    var tagA = `<a id="btnPersonalize" rel="no-follow" class="single_personalize_button button alt personalize dastomize_button_id_personalize ` + _verifyCustomAttributeNeededClass + `"
    data-fancybox="customize" data-options='${fancyboxOptions}' data-doa-url="${url}" data-src="${url}" href="javascript:;">
        ${textButtonPersonalize ? textButtonPersonalize : 'Personalize'}
    </a>`;

    var inputPreview = `<input type="hidden" name="personalized-preview" id="personalized-preview" value="" />`;
    var inputJson = `<input type="hidden" name="personalized-json" id="personalized-json" value="" />`;
    var inputProductId = `<input type="hidden" name="personalized-product-id" id="personalized-product-id" value="` + pid + `" />`;
    var inputStoreId = `<input type="hidden" name="personalized-store-id" id="personalized-store-id" value="` + sid + `" />`;
    var inputCustomVariant = `<input type="hidden" name="personalized-custom-variant" id="personalized-custom-variant" value="" />`;
    jQuery(inputPreview).insertBefore("button.single_add_to_cart_button");
    jQuery(inputProductId).insertBefore("button.single_add_to_cart_button");
    jQuery(inputStoreId).insertBefore("button.single_add_to_cart_button");
    jQuery(inputJson).insertBefore("button.single_add_to_cart_button");
    jQuery(inputCustomVariant).insertBefore("button.single_add_to_cart_button");

    jQuery(tagA).insertBefore("button.single_add_to_cart_button");
    // jQuery("button.single_add_to_cart_button, div.wcppec-checkout-buttons, div.pewc-group-wrap").hide();
    jQuery("button.single_add_to_cart_button").addClass('verify-custom-attributes-needed');
    jQuery("button.single_add_to_cart_button, div.wcppec-checkout-buttons").hide();
    jQuery("#wc-stripe-payment-request-wrapper, #wc-stripe-payment-request-button-separator").hide();
    var windowsize = jQuery(window).width();
    var sticky = jQuery('.sticky-add-to-cart-wrapper').find('.sticky-add-to-cart');
    if (windowsize <= 768) {
        sticky.addClass('sticky-personalize--active');
        jQuery('body').addClass('has-sticky-product-cart');
    } else {
        sticky.removeClass('sticky-personalize--active');
    }
    jQuery('a#btnPersonalize').on('click', function () {
        var iframeUrl = jQuery(this).data('doa-url');
        if (jQuery('input.variation_id').val()) {
            iframeUrl = iframeUrl + '&ex_variant_id=' + jQuery('input.variation_id').val();
        }
        var _ul = jQuery('ul.my-variable-items-wrapper');
        var _verifyCustomAttributes = true;
        if (_ul.length > 0) {
            _ul.each(function () {
                var _li = jQuery(this).children('li.selected');
                if (_li.length > 0) {
                    iframeUrl = iframeUrl + '&' + jQuery(this).attr('data-attribute-name') + '=' + _li.attr('data-value');
                } else {
                    iframeUrl = iframeUrl + '&' + jQuery(this).attr('data-attribute-name') + '=0';
                    //show required custom attribute if dont select
                    var _req = jQuery(this).parent().siblings();
                    _req.children('label').children('span').children('span').animate({
                        fontSize: "22px",
                        width: "auto",
                        marginTop: "-12px"
                    }, {
                        duration: 300,
                        complete: function () {
                            jQuery(this).css({
                                display: "unset",
                                fontSize: "",
                                width: "",
                                position: "absolute",
                                marginTop: ""
                            });
                        }
                    });
                    _verifyCustomAttributes = false;
                }
            });
        }

        var _dd = jQuery('select.my-select-dr');
        if (_dd.length > 0) {
            _dd.each(function () {
                var str = jQuery(this).val() + '';
                if (str != '') {
                    iframeUrl = iframeUrl + '&' + jQuery(this).attr('data-attribute-name') + '=' + str;
                } else {
                    iframeUrl = iframeUrl + '&' + jQuery(this).attr('data-attribute-name') + '=0';
                    var _req = jQuery(this).parent().siblings();
                    _req.children('label').children('span').children('span').animate({
                        fontSize: "22px",
                        width: "auto",
                        marginTop: "-12px"
                    }, {
                        duration: 300,
                        complete: function () {
                            jQuery(this).css({
                                display: "unset",
                                fontSize: "",
                                width: "",
                                position: "absolute",
                                marginTop: ""
                            });
                        }
                    });
                    _verifyCustomAttributes = false;
                }
            });
        }
        //save local storage custom attributes
        localStorage.setItem('custom-attributes-selected', jQuery("input#personalized-custom-variant").val());

        iframeUrl = iframeUrl + '&current_url=' + window.location.href.replace('#customize', '').replace(window.location.search, '');
        jQuery(this).data('src', iframeUrl);


        if (!isSimple) {
            let checkDisplay = jQuery('div.single_variation').css('display');
            if (checkDisplay !== 'block') {
                return false;
            }

            let verifyCustomAttribute = jQuery(this).hasClass('verify-custom-attributes-needed');
            if (verifyCustomAttribute) {
                return false;
            }
        }
    });
    jQuery("[data-fancybox=\"customize\"]").fancybox({
        helpers: {
            overlay: {
                closeClick: false
            }
        },
        afterShow: function (instance, current) {
            // var btnClose = '<button data-fancybox-close="" class="fancybox-button fancybox-button--close" title="Close" style="position: absolute; z-index: 1; top: 0px; right: 0px; height: 50px; width: 50px;"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 10.6L6.6 5.2 5.2 6.6l5.4 5.4-5.4 5.4 1.4 1.4 5.4-5.4 5.4 5.4 1.4-1.4-5.4-5.4 5.4-5.4-1.4-1.4-5.4 5.4z"></path></svg></button>';
            // jQuery('.fancybox-toolbar .fancybox-button--close').remove();
            // jQuery(btnClose).insertBefore("iframe.fancybox-iframe");
            var iframe = document.getElementsByClassName("fancybox-iframe")[0];

            // var att = document.createAttribute("data-hj-allow-iframe");
            // att.value = "true";
            // iframe.setAttributeNode(att);

            setTimeout(function () {
                iframe.contentWindow.postMessage({ productId: productId }, webUrl);
            }, 3000);
        },
        beforeClose: function () {
            var iframe = document.getElementsByClassName("fancybox-iframe")[0];
            iframe.contentWindow.postMessage({ productId: productId, action: 'save_session' }, webUrl);
            if (!localStorage.getItem(`pId:` + productId + `:image:finished`)) {
                // return window.confirm("Your design will be lost, do you really want to close it ?");
            } else {
                localStorage.removeItem(`pId:` + productId + `:image:finished`);
            }
        },
        afterClose: function () {
        }
    });

    dastomize_style_personalize_button(windowsize);
    jQuery(window).scroll(function () {
        dastomize_style_personalize_button(windowsize);
    });
}

function dastomize_js_action_woocommerce_after_single_product(productId, $textPersonalization) {
    loadIndexedDB(`pId:` + productId + `:image`, function (data) {
        var windowsize = jQuery(window).width();
        data = JSON.parse(data);
        var json = data.json;
        var previewUrl = data.preview;
        // var tagA = `<a id=\"previewImg\" href=\"${previewUrl}\" data-fancybox=\"images\">Preview Your Personalization</a>`;
        const tagA = `
            <a id="previewImg" class="dastomize_button_id_preview_your_personalization">
                ${$textPersonalization ? $textPersonalization : 'Preview Your Personalization'}
            </a>
        `;
        // jQuery("div.product-gallery, div.woocommerce-product-gallery").children().hide();
        // jQuery("div.product-gallery").append(tagA);
        // jQuery("div.product-gallery a#previewImg").trigger("click");
        jQuery("button.single_add_to_cart_button, div.wcppec-checkout-buttons").show();

        jQuery(tagA).insertBefore("a#btnPersonalize");
        // jQuery("a#previewImg").trigger("click");
        dastomize_modal_preview_Image(previewUrl)
        jQuery("a#btnPersonalize").text('EDIT DESIGN');
        jQuery("a#btnPersonalize").addClass('edit-design');
        jQuery("button.single_add_to_cart_button").addClass('edit-design');
        jQuery("button.single_add_to_cart_button").addClass('margin-left-50');
        var src = jQuery("a#btnPersonalize").data('src');
        jQuery("a#btnPersonalize").data('src', src);

        jQuery("input#personalized-preview").val(previewUrl);
        jQuery("input#personalized-json").val(json);

        //check custom attribute
        var _dataCustomAttributeBefore = localStorage.getItem('custom-attributes-selected');
        var _dataCustomAttributeCurrent = jQuery("input#personalized-custom-variant").val();
        if (_dataCustomAttributeBefore != _dataCustomAttributeCurrent) {
            jQuery("a#btnPersonalize").text('PERSONALIZE');
            jQuery("a#btnPersonalize").removeClass('edit-design');
            jQuery("button.single_add_to_cart_button").removeClass('edit-design');
            jQuery("button.single_add_to_cart_button").removeClass('margin-left-50');
            jQuery("button.single_add_to_cart_button, div.wcppec-checkout-buttons").hide();
            jQuery("#wc-stripe-payment-request-wrapper, #wc-stripe-payment-request-button-separator").hide();
            jQuery("a#previewImg").hide();
        }

        jQuery("a#previewImg").on('click', (e) => {
            e.preventDefault()
            dastomize_modal_preview_Image(previewUrl)
        })

        dastomize_style_personalize_button(windowsize);
        jQuery(window).scroll(function () {
            dastomize_style_personalize_button(windowsize);
        });
        dastomize_style_preview_your_personalization(windowsize);
    });
}

function dastomize_js_plugin_personalized_hide_name_in_cart_checkout() {
    jQuery("dt.variation-ViewPersonalized").remove();
    jQuery("dt.variation-personalized_preview_url").remove();
    jQuery("dd.variation-personalized_preview_url").remove();
}

function dastomize_js_plugin_personalized_clear_storage(ids) {
    var ids = ids.split(',');
    ids.forEach(id => {
        deleteObjectIndexedDB(`pId:` + id + `:image`, 'personalizedIndex');
    });
}

/**
 * @description modal preview personalized image
 * @param {*} previewSrc
 */
async function dastomize_modal_preview_Image(previewSrc) {
    jQuery('body').append(
        `
        <div id="doa-modal" class="doa-modal" onclick="dastomize_handle_close_modal(event)">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-body">
                        <div class="btn-wrapper">
                            <button
                                onclick="dastomize_handle_close_modal(event)"
                                type="button"
                                class="doa-btn-close"
                            ></button>
                        </div>
                        <img
                            id="img-preview"
                            src="${previewSrc}"
                            alt="Preview Your Personalization"
                        />
                    </div>

                    <div class="modal-footer">
                        <div class="btn-action-group">
                            <button type="button" class="btn-add-to-cart" onclick="dastomize_add_to_cart(event)">Add To Cart</button>
                        </div>

                        <button
                            onclick="dastomize_handle_close_modal(event)"
                            type="button"
                            class="btn btn-secondary btn-close-preview"
                        >
                            Close Preview
                        </button>
                    </div>
                </div>
            </div>
        </div>
    `)
}

/**
 * @description close modal preview personalized
 */
async function dastomize_handle_close_modal(e) {
    const { id, className } = e.target;
    const ids = ['img-preview'];
    const classes = ['modal-body', 'btn-action-group'];

    if ((id && ids.includes(id)) || (className && classes.includes(className))) return false;
    jQuery("#doa-modal").remove()
}

function dastomize_add_to_cart(e) {
    dastomize_handle_close_modal(e)
    jQuery("button.single_add_to_cart_button.verify-custom-attributes-needed").trigger("click")
}

function dastomize_style_personalize_button(windowsize) {
    const btnAddToCard = jQuery("button.single_add_to_cart_button");
    const btnPersonalize = jQuery("a.single_personalize_button");
    const stickyActive = jQuery("body").find(".sticky-add-to-cart.sticky-add-to-cart--active");

    const fontSize = btnAddToCard.css("font-size");
    const minWidth = btnAddToCard.css("min-width");
    const height = btnAddToCard.css("height");
    const minHeight = btnAddToCard.css("min-height");
    const margin = btnAddToCard.css("margin");

    const btnEditDesign = jQuery(btnPersonalize).hasClass('edit-design');

    btnPersonalize.css({
        "font-size": fontSize,
        "min-width": minWidth,
        "height": height,
        "min-height": minHeight,
        "margin": margin,
        "display": "flex",
        "align-items": "center",
        "justify-content": "center",
    });

    if (windowsize > 768) {
        if (stickyActive.length) {
            btnPersonalize.css({
                "margin-right": "5px",
                "height": height,
                "min-height": minHeight,
            });
        } else {
            btnPersonalize.css({
                "margin-right": "unset",
            });

            if (btnEditDesign) {
                const calHeight = (Number(height.replace("px", "")) / 100) * 70;
                const calMinHeight = (Number(minHeight.replace("px", "")) / 100) * 70;
                btnPersonalize.css({
                    "height": calHeight,
                    "min-height": calMinHeight,
                });
            }
        }
    }
}

function dastomize_style_preview_your_personalization(windowsize) {
    const btnAddToCard = jQuery("button.single_add_to_cart_button");
    const btnPreviewYourPersonalization = jQuery("a.dastomize_button_id_preview_your_personalization");

    const fontSize = btnAddToCard.css("font-size");
    const minWidth = btnAddToCard.css("min-width");
    const height = btnAddToCard.css("height");
    const minHeight = btnAddToCard.css("min-height");
    const calHeight = (Number(height.replace("px", "")) / 100) * 70;
    const calMinHeight = (Number(minHeight.replace("px", "")) / 100) * 70;

    btnPreviewYourPersonalization.css({
        "font-size": fontSize,
        "min-width": minWidth,
        "height": calHeight,
        "min-height": calMinHeight,
    });
}
