<?php

function dastomize_get_stores()
{
	$webURL = DASTOMIZE_APP_URL;
	
	$apiToken = get_option('settings_page_api_token');
	$env = dastomize_env('DAST_APP_ENV', 'prod');
	if ($env == 'local') {
		return [
			['id' => 1, 'name' => 'Local Store Cubebik'],
			['id' => 2, 'name' => 'Local Store Cubebik Test']
		];
	}
	
	$remoteUrl = $webURL . DASTOMIZE_APP_API_GET_STORES;
	$args = array(
		'timeout'     => 300,
		'headers'   => array(
			'Authorization' => 'Bearer ' . $apiToken,
		),
	);
	$response = wp_remote_get($remoteUrl, $args);
    $body = json_decode($response['body'], true);
    return $body['data'];
}