<?php
$default_tab = null;
$tab = isset($_GET['tab']) ? sanitize_text_field($_GET['tab']) : $default_tab;
?>
<div class="wrap">
    <h1><?php echo esc_html( get_admin_page_title() ); ?></h1>
    <nav class="nav-tab-wrapper">
        <a href="?page=dastomize-apps-menu" class="nav-tab <?php if($tab===null):?>nav-tab-active<?php endif; ?>">Home</a>
        <a href="?page=dastomize-apps-menu&tab=support" class="nav-tab <?php if($tab === 'support'):?>nav-tab-active<?php endif; ?>">Support</a>
        <!-- <a href="?page=dastomize-apps-menu&tab=settings" class="nav-tab <?php if($tab==='settings'):?>nav-tab-active<?php endif; ?>">Settings</a> -->
    </nav>

    <div class="tab-content">
    <?php switch($tab) :
        case 'support':
            include(DASTOMIZE_HTML . 'support.php');
            break;
        default:
            include(DASTOMIZE_HTML . 'connection.php');
            break;
    endswitch; ?>
    </div>
</div>
<script type="text/javascript">window.$crisp=[];window.CRISP_WEBSITE_ID="ffb1ff4b-8e27-4b5b-aea1-8047bd2db171";(function(){d=document;s=d.createElement("script");s.src="https://client.crisp.chat/l.js";s.async=1;d.getElementsByTagName("head")[0].appendChild(s);})();</script>
