<?php
add_filter( 'woocommerce_webhook_http_args', 'dastomize_woocommerce_webhook_http_args', 10, 3 );
function dastomize_woocommerce_webhook_http_args( $http_args, $arg, $this_id ) {
    $apiToken = get_option('settings_page_api_token');
	
	if( ! isset( $http_args['headers'] ) ){
		$http_args['headers'] = array();
    }

    $str = str_replace('==', '$DOA', base64_encode($apiToken));
    $custom_header_data = [
        'X-DOA-Authorization' => $str,
        'X-DOA-Store-Id' => get_option('settings_page_app_store')
	];

	$http_args['headers'] = array_merge( $http_args['headers'], $custom_header_data );

	return $http_args;
}

